<template>
	<Background :custom="true">
		<CardLayout>
			<template slot="head">
				<CommonHeader
					:title="subcategory ? localizedCategoryName(subcategory).toUpperCase() : ''"
				></CommonHeader>
			</template>
			<template slot="top">
				<div class="top">
					<Background class="background" :custom="true">
						<VariableLogo class="logo" :custom="true"></VariableLogo>
					</Background>
				</div>
			</template>
			<template slot="body">
				<div class="info">
					<div
						class="product"
						v-for="(product, index) of products"
						:key="index"
						@click="seeProduct(product.id)"
					>
						<Thumbnail class="thumbnail" :src="product.photosURL[0]"> </Thumbnail>
						<div class="plaque">
							<div class="info">
								<span>{{ localizedProductName(product) }}</span>
								<span class="description">{{ product.description }}</span>
								<span class="price">{{ formatPrice(localizedProductPrice(product), true) }}</span>
							</div>
							<div class="content-next">
								<Next class="next"></Next>
							</div>
						</div>

						<!--<div class="middle-info">
							<span class="name">{{localizedProductName(product)}}</span>
							<div v-if="showReviews" @click="seeReviews(product.id)" class="likes-section">
								<div class="like-container">
									<LikeButton class="like" :selected="true"></LikeButton>
									<span>{{product.goodReviews}}</span>
								</div>
								<div class="like-container">
									<LikeButton class="like" :selected="true" :positive="false"></LikeButton>
									<span>{{product.badReviews}}</span>
								</div>
								<CommentsButton :number="product.totalReviews"></CommentsButton>
							</div>
						</div>-->
						<!-- <span
							:set="price = localizedProductPrice(product)"
							class="price"
						>{{ price ? formatPrice(price.ammount): ''}}</span>
						<Next></Next> -->
					</div>
				</div>
				<MiniCart></MiniCart>
			</template>
		</CardLayout>
	</Background>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import CardLayout from '@/layouts/CardLayout.vue'
import Background from '@/components/Background.vue'
import Next from '@/components/Next.vue'
import CounterButton from '@/components/CounterButton.vue'
import MiniCart from '@/components/MiniCart.vue'
import Thumbnail from '@/components/Thumbnail.vue'
import Product from '@/models/Product'
import { User } from '@/models/User'
import SubcategoryModel from '@/models/Subcategory'
import SpinnerHolder from '@/components/SpinnerHolder.vue'
import CommonHeader from '@/components/CommonHeader.vue'
import CommentsButton from '@/components/CommentsButton.vue'
import LikeButton from '@/components/LikeButton.vue'
import { localizedProductPrice } from '../mixins/MenuLocalization'
import VariableLogo from '@/components/VariableLogo.vue'

@Component({
	components: {
		Background,
		VariableLogo,
		CardLayout,
		CommonHeader,
		Next,
		CounterButton,
		Thumbnail,
		SpinnerHolder,
		MiniCart,
		LikeButton,
		CommentsButton
	}
})
export default class Subcategory extends Vue {
	products: Array<Product> = []
	subcategory: SubcategoryModel | null = null
	user: User | null = this.$store.state.user
	showReviews = false

	seeProduct(productId: string) {
		this.$router.push('/products/' + productId)
	}

	seeReviews(productId: string) {
		this.$router.push('/reviews/' + productId)
	}

	getProductsOfSubcategory(subCategoryId: string) {
		const products = this.$store.getters.products as Product[]
		return products
			.filter(p => p.subCategoryId == subCategoryId && localizedProductPrice(p))
			.sort((c, n) => c.order - n.order)
	}

	getSubcategory(subCategoryId: string) {
		const subcategories = this.$store.getters.subcategories as SubcategoryModel[]
		const subcategory = subcategories.find(c => c.id == subCategoryId)
		return subcategory || null
	}

	created() {
		this.products = this.getProductsOfSubcategory(this.$route.params.subcategoryId)
		this.subcategory = this.getSubcategory(this.$route.params.subcategoryId)
		this.showReviews = this.$store.state.menu ? this.$store.state.menu.showReviews : false
	}
}
</script>

<style lang="scss" scoped>
.top {
	height: 100%;
	width: 100%;
	color: #ffffff;
	display: flex;
	justify-content: center;
	align-items: center;
	// background-image: url('~@/assets/img/hojas.png');
	background-size: contain;
	background-position: bottom;
}

.top .logo {
	height: 100%;
	width: 50%;
	margin: 10px auto 20px auto;
	background-repeat: no-repeat;
	background-position: center;
	position: relative;
	display: flex;
	background-size: contain;
}

.home-body {
	padding: 0.5em 0em;
}

.content-next {
	margin: auto 0 !important;
	.next {
		background-color: transparent !important;
	}
}

.info {
	width: 100%;
	display: flex;
	flex-direction: column;
	padding-bottom: 3vh;

	.product {
		display: inline-flex;
		margin: 0.5em;
		padding: 0.5em;
		width: 90%;
		background: #ffffff;
		box-shadow: 0px 1px 4px rgba(0, 0, 0, 0.25);
		border-radius: 4px;

		.plaque {
			display: flex;
			width: 100%;
			flex-direction: row;
			justify-content: space-around;
			.info {
				font-weight: bold;
				margin-right: auto;
				font-size: 16px;
				line-height: 19px;
				margin-left: 10px;
				.description {
					font-weight: normal;
					color: #4f4f4f;
					font-size: 14px;
					line-height: 16px;
					overflow: hidden;
					display: -webkit-box;
					-webkit-line-clamp: 2;
					-webkit-box-orient: vertical;
				}
				.price {
					margin-top: 15px;
					font-size: 23px;
					font-weight: 800;
					color: #feca38;
					display: block;
				}
			}

			.seeProduct {
				width: 20px;
				height: 20px;
			}
		}

		.likes-section {
			//   padding: 10px;
			display: flex;
			justify-content: flex-start;
			margin-top: 10px;

			.like-container {
				margin: 0px 10px 0px 0px;
				display: flex;
				font-size: 10px;
				justify-content: flex-start;
				align-items: center;
			}
		}

		.name {
			font-weight: bold;
			margin-right: auto;
			font-size: 16px;
			line-height: 19px;
			// margin-left: 10px;
		}

		.middle-info {
			margin-left: 25px;
		}
		.thumbnail {
			width: 95.24px;
			height: 90.46px;
			border-radius: 10px;
		}
		// .price {
		// 	border-radius: 50%;
		// 	margin-left: auto;
		// 	margin-right: 20px;
		// }
	}
}
</style>
